<!DOCTYPE html>
<html>
  <head>
    <title>Ej: Esfera</title>
    <style>
      html, body { margin: 0; padding: 0; overflow: hidden; }
    </style>
  </head>
  <body>
    <script src="js/three.js"></script>
	<script src="js/controls/OrbitControls.js"></script>
    <script>
		var scene, aspect, camera, renderer, controls;
		var startTime = Date.now();
		var fan;
		var strip;
		var tapa;
		
		class TRIANGLE_FAN{	
		  constructor( Geometria ){
		    this.geometria = Geometria;
			console.log(this.geometria);
		  }  
		  draw(){			
			for( var i=2; i<this.geometria.vertices.length; i++ ){
			  this.geometria.faces.push( new THREE.Face3(0,i-1,i) );
			}
			this.geometria.computeFaceNormals();
			var materialFan = new THREE.MeshBasicMaterial( { color: 0x3333DD, side:THREE.DoubleSide } );
			var fan = new THREE.Mesh( this.geometria, materialFan );
			scene.add( fan );
		  }
		}
		
		class TRIANGLE_STRIP{	
		  constructor( Geometria ){
		    this.geometria = Geometria;
			console.log(this.geometria);
		  }  
		  draw(){			
			for( var i=2; i<this.geometria.vertices.length; i++ ){
			  this.geometria.faces.push( new THREE.Face3(i-2,i-1,i) );
			}
			this.geometria.computeFaceNormals();
			var materialStrip = new THREE.MeshBasicMaterial( { color: 0x3333DD, side:THREE.DoubleSide } );
			var strip = new THREE.Mesh( this.geometria, materialStrip );
			scene.add( strip );
		  }
		}
		
		init();
		animate();
	
		function init(){
			scene = new THREE.Scene();
			aspect = window.innerWidth / window.innerHeight;
			camera = new THREE.PerspectiveCamera( 45, aspect, 0.1, 1000);
			renderer = new THREE.WebGLRenderer();
			renderer.setSize( window.innerWidth, window.innerHeight );
			document.body.appendChild( renderer.domElement );
			controls = new THREE.OrbitControls( camera, renderer.domElement );
            				  
			var size = 10;
			var arrowSize = 1;
			var divisions = size;
			var origin = new THREE.Vector3( 0, 0, 0 );
			var x = new THREE.Vector3( 1, 0, 0 );
			var y = new THREE.Vector3( 0, 1, 0 );
		  	var z = new THREE.Vector3( 0, 0, 1 );
			var color1 = new THREE.Color( 0xFFFFFF );
		  	var color2 = new THREE.Color( 0x333333 );
		  	var colorR = new THREE.Color( 0xAA3333 );
		  	var colorG = new THREE.Color( 0x33AA33 );
		  	var colorB = new THREE.Color( 0x333366 );
		  
		  	//CREAR LAS GRILLAS PARA EL ESCENARIO
		  	var axesHelper = new THREE.AxesHelper( size );
		  	var gridHelperXY = new THREE.GridHelper( size, divisions, color1, color1);
		  	var gridHelperXZ = new THREE.GridHelper( size, divisions, color2, color2 );
		  	var gridHelperYZ = new THREE.GridHelper( size, divisions, color2, color2 );
            
            //ROTARLAS PARA QUE QUEDEN EN EL ESPACIO ADECUADO
            gridHelperXY.rotateOnWorldAxis ( x, THREE.Math.degToRad(90) );
            gridHelperXZ.rotateOnWorldAxis ( y, THREE.Math.degToRad(90) );
            gridHelperYZ.rotateOnWorldAxis ( z, THREE.Math.degToRad(90) );
            
            //CREAR LAS FLECHAS QUE INDICAN LOS EJES DE COORDENADAS 3D
            var arrowX = new THREE.ArrowHelper( x, origin, arrowSize, colorR );
            var arrowY = new THREE.ArrowHelper( y, origin, arrowSize, colorG );
            var arrowZ = new THREE.ArrowHelper( z, origin, arrowSize, colorB );
			
			//CREAR ILUMINACIÓN
            var ambient = new THREE.AmbientLight( 0xffffff, 2 );
            scene.add( ambient );
            
            var pointLight = new THREE.PointLight( 0xffffff, 1, 100 );
            pointLight.position.set( 5, 5, -5 );
            scene.add( pointLight );
			
			//CREAR LAS GEOMETRÍAS
            //Punto
			var punto0 = new THREE.Vector3(0,0.5,0);
            var geometria = new THREE.Geometry();
            var geometria2 = new THREE.Geometry();
            var geometria3 = new THREE.Geometry();
			var geometria4 = new THREE.Geometry();
			var geometria5 = new THREE.Geometry();
			var geometria6 = new THREE.Geometry();
			var geometria7 = new THREE.Geometry();
			var geometria8 = new THREE.Geometry();
			var geometria9 = new THREE.Geometry();
			var geometria10 = new THREE.Geometry();
			var geometria11 = new THREE.Geometry();
			var geometriaf = new THREE.Geometry();
            
            var radio = 1.0;
			var res = 30.0;
			geometria.vertices.push( punto0 );
            
            for( var i = 0; i <= res; i++){
                    
                var punto = new THREE.Vector3();
				var punto2 = new THREE.Vector3();
                var punto3 = new THREE.Vector3();
                var punto4 = new THREE.Vector3();
				var punto5 = new THREE.Vector3();
				var punto6 = new THREE.Vector3();
				var punto7 = new THREE.Vector3();
				var punto8 = new THREE.Vector3();
				var punto9 = new THREE.Vector3();
				var punto10 = new THREE.Vector3();
				var punto11 = new THREE.Vector3();
                var puntof = new THREE.Vector3();
                    
				punto.x = 2*radio * Math.cos( (2 * Math.PI * i )/ res );
                punto.y = 0
                punto.z = 2*radio * Math.sin( (2 * Math.PI * i )/ res );
                
				punto2.x = punto.x*1.5;
				punto2.y = -0.7;
				punto2.z = punto.z*1.5;
                
                punto3.x = punto.x*1.8;
                punto3.y = -1.4;
                punto3.z = punto.z*1.8;
                
				punto4.x = punto.x*1.9;
                punto4.y = -2.1;
                punto4.z = punto.z*1.9;
				
				punto5.x = punto.x*2.0;
                punto5.y = -2.8;
                punto5.z = punto.z*2.0;
				
				punto6.x = punto.x*2.1;
                punto6.y = -3.5;
                punto6.z = punto.z*2.1;
				
				punto7.x = punto.x*2.0;
                punto7.y = -4.2;
                punto7.z = punto.z*2.0;
				
				punto8.x = punto.x*1.9;
                punto8.y = -4.9;
                punto8.z = punto.z*1.9;
				
				punto9.x = punto.x*1.8;
                punto9.y = -5.6;
                punto9.z = punto.z*1.8;
				
				punto10.x = punto.x*1.5;
                punto10.y = -6.3;
                punto10.z = punto.z*1.5;
				
				punto11.x = 2*radio * Math.cos( (2 * Math.PI * i )/ res );
                punto11.y = -7.0;
                punto11.z = 2*radio * Math.sin( (2 * Math.PI * i )/ res );
                
				puntof.x = 2*radio * Math.cos( (2 * -Math.PI * i )/ res );
                puntof.y = -7.0;
                puntof.z = 2*radio * Math.sin( (2 * -Math.PI * i )/ res );
                
                geometria.vertices.push( punto );
				geometria2.vertices.push( punto );
				geometria2.vertices.push( punto2 );
                geometria3.vertices.push( punto2 );
                geometria3.vertices.push( punto3 );
                geometria4.vertices.push( punto3 );
                geometria4.vertices.push( punto4 );
				geometria5.vertices.push( punto4 );
                geometria5.vertices.push( punto5 );
				geometria6.vertices.push( punto5 );
                geometria6.vertices.push( punto6 );
				geometria7.vertices.push( punto6 );
                geometria7.vertices.push( punto7 );
				geometria8.vertices.push( punto7 );
                geometria8.vertices.push( punto8 );
				geometria9.vertices.push( punto8 );
                geometria9.vertices.push( punto9 );
				geometria10.vertices.push( punto9 );
                geometria10.vertices.push( punto10 );
				geometria11.vertices.push( punto10);
                geometria11.vertices.push( punto11 );
                geometriaf.vertices.push( puntof );
                
                }
			fan = new TRIANGLE_FAN(geometria);	
			fan.draw();
            fan = new TRIANGLE_FAN(geometriaf);	
			fan.draw();
            strip = new TRIANGLE_STRIP(geometria2);
			strip.draw();
            
            strip = new TRIANGLE_STRIP(geometria3);
            strip.draw();
			
			strip = new TRIANGLE_STRIP(geometria4);
            strip.draw();
			
			strip = new TRIANGLE_STRIP(geometria5);
            strip.draw();
			
			strip = new TRIANGLE_STRIP(geometria6);
            strip.draw();
			
			strip = new TRIANGLE_STRIP(geometria7);
            strip.draw();
			
			strip = new TRIANGLE_STRIP(geometria8);
            strip.draw();
			
			strip = new TRIANGLE_STRIP(geometria9);
            strip.draw();
			
			
			strip = new TRIANGLE_STRIP(geometria10);
            strip.draw();
			
			strip = new TRIANGLE_STRIP(geometria11);
            strip.draw();
			//CREAR LOS MATERIALES
            var matLinea = new THREE.LineBasicMaterial( { color: 0xFFFFFF } );
			
			//CREAR LOS OBJETOS
			
			var cono = new THREE.Line( geometria, matLinea );
			var tubo = new THREE.Line( geometria2, matLinea );
            var tubo2 = new THREE.Line( geometria3, matLinea );
			var tubo3 = new THREE.Line( geometria4, matLinea );
			var tubo4 = new THREE.Line( geometria5, matLinea );
			var tubo5 = new THREE.Line( geometria6, matLinea );
			var tubo6 = new THREE.Line( geometria7, matLinea );
			var tubo7 = new THREE.Line( geometria8, matLinea );
			var tubo8 = new THREE.Line( geometria9, matLinea );
			var tubo9 = new THREE.Line( geometria10, matLinea );
			var tubo10 = new THREE.Line( geometria11, matLinea );
            var conof = new THREE.Line( geometriaf, matLinea );

		  	//AGREGAR A LA ESCENA
		  	scene.add( gridHelperXY );
            scene.add( gridHelperXZ );
		  	scene.add( arrowX );	
		  	scene.add( arrowY );	
		  	scene.add( arrowZ );	
			scene.add( cono );
			scene.add( tubo );
			scene.add( tubo2 );
            scene.add( tubo3 );
			scene.add( tubo4 );
			scene.add( tubo5 );
			scene.add( tubo6 );
			scene.add( tubo7 );
			scene.add( tubo8 );
			scene.add( tubo9 );
			scene.add( tubo10 );
			//scene.add( conof );
			
			camera.position.x = 3;
			camera.position.y = 8;	 
		  	camera.position.z = 10;
			
		  	camera.lookAt( origin );
			}
    
    function animate() {
        render();
		controls.update(); // required if controls.enableDamping = true, or if controls.autoRotate = true
        requestAnimationFrame( animate );
    }
    
    function render(){
        renderer.render( scene, camera );
    }
    </script>
  </body>
</html>
